; Script di Jaws per eMule 
; Rilasciati da Bizio il 23/12/2004. 
;Modificati per adattamento ad Emule standard, By Alessandro Rossetti, 14/02/2005
; Realizzati utilizzando Jaws 4.51 e eMule Adunanza 3.4, 
; versione di eMule 0.42 modificata ed ottimizzata per utenti Fastweb.
; Riadattamento utilizzando Jaws 6.0.406 e Emule 0.45B
; Per informazioni, problemi, proposte ed altre domande, scrivetemi a fabrizio@people punto it.

Include "hjconst.jsh"
Include "emule.jsm"


Globals
 int IsEmuleFirstTime 

Void Function AutoStartEvent ()
; Dice agli utenti inesperti quali tasti premere per cominciare ad utilizzare eMule AdunanzA.

If IsEmuleFirstTime == 0 Then
 Let IsEmuleFirstTime = 1
 SayMessage (ot_app_start, MsgAutoStart_L, MsgAutoStart_S) 
EndIf 

EndFunction 


Function RaggiungiBarra (string barra)
; Si porta sulla barra degli strumenti o sulla barra di stato.

InvisibleCursor ()
RouteInvisibleToPc ()
If Barra=="strumenti" Then
 JAWSPageUp ()
 NextLine ()
 NextLine ()
Else 
  JAWSPageDown ()
EndIf 
JawsHome ()

EndFunction


Int Function CercaParola (string parola)
; Cerca una parola in un'area circoscritta della finestra e vi posiziona il cursore invisibile.
; La parola cambia a seconda dello script che richiama questa funzione. 

Var
int counter

let counter = 0
While (GetWord () != parola && counter<40)
 Let counter = counter + 1
 NextWord ()
EndWhile
If GetWord ()==parola Then
 Return TRUE
Else
 SayMessage (ot_jaws_message, MsgNotFound_L, MsgNotFound_S)
 Return FALSE
EndIf

EndFunction


Script HotKeyHelp ()
; Mostra l'elenco dei tasti di scelta rapida utilizzabili nelle finestre di eMule AdunanzA.

If UserBufferIsActive () Then
 UserBufferDeactivate ()
EndIf
SayMessage (ot_user_buffer, MsgHotKeyHelp_L, MsgHotKeyHelp_S)

EndScript 


Script frecciaGiu ()
; Negli elenchi di file, sposta il focus sull'elemento successivo e lo legge. 
; Negli altri casi, esegue il comando freccia gi standard. 

If Not IsPCCursor () || UserBufferIsActive () Then 
 PerformScript SayNextLine ()
Else
 SpeechOff ()
 {downarrow}
 Pause ()
 SpeechOn ()
 SayLine ()
EndIf 

EndScript


Script FrecciaSu ()
; Negli elenchi di file, sposta il focus sull'elemento precedente e lo legge. 
; Negli altri casi, esegue il comando freccia su standard di Windows.

If Not IsPCCursor () || UserBufferIsActive () Then 
 PerformScript SayPriorLine ()
Else
 SpeechOff ()
 {uparrow}
 Pause ()
 SpeechOn ()
 SayLine ()
EndIf 

EndScript


Script Home ()
; In un elenco di file, sposta il cursore sul primo elemento dell'elenco e lo legge. 
; Quando  attivo il cursore Jaws o il cursore invisibile, porta il cursore all'inizio della riga corrente.

If Not IsPCCursor () Then
 JawsHome ()
 SayWord ()
Else
 {Home}
 SayLine ()
EndIf 

EndScript 


Script End ()
; In un elenco di file, sposta il cursore sull'ultimo elemento dell'elenco e lo legge. 
; Quando  attivo il cursore Jaws o il cursore invisibile, porta il cursore alla fine della riga corrente.

If Not IsPCCursor () Then
 JawsEnd ()
Else
 {End}
 SayLine ()
EndIf 

EndScript 


Script Aiuto ()
; Apre la guida di eMule AdunanzA.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Aiuto")
If Parolatrovata Then
 SayMessage (ot_jaws_message, MsgAiuto_L, MsgAiuto_S)
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script FileCondivisi ()
; Apre la finestra File Condivisi.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("file")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script Messaggi ()
; Apre la finestra Messaggi.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Messaggi")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script irc ()
; Apre la finestra Irc.

Var
 int parolatrovata
SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Irc")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script cerca ()
; Apre la finestra Cerca.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Cerca")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script Kademlia ()
; Apre la finestra Kademlia.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Kad")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script trasferimenti ()
; Apre la finestra Trasferimenti.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Trasf")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script preferenze ()
; Apre la finestra Preferenze.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Prefer")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script ConnettiDisconnetti ()
; Connette o disconnette dalla rete eDonkey.

Var
 int ParolaTrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let ParolaTrovata = CercaParola ("Kad")
If ParolaTrovata Then
 PriorWord ()
 RouteJAWSToInvisible ()
 If GetWord () == "Connetti" Then
  SayMessage (ot_jaws_message, MsgConnessioneEdonkey_L, MsgConnessioneEdonkey_S)
 ElIf GetWord () == "Disconnetti" Then  
  SayMessage (ot_jaws_message, MsgDisconnessioneEdonkey_L, MsgDisconnessioneEdonkey_S)
 Else
  SayMessage (ot_jaws_message, MsgIgnoroConnessioneEdonkey_L, MsgIgnoroConnessioneEdonkey_S)
  SayMessage (ot_jaws_message, MsgShiftF9, "")
 EndIf
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script Server ()
; Apre la finestra Server.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Server")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script Statistiche ()
; Apre la finestra Statistiche.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Statistiche")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript


Script Strumenti ()
; Apre il men Strumenti. 

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("strumenti")
let Parolatrovata = CercaParola ("Strumenti")
If Parolatrovata Then
 RouteJAWSToInvisible ()
 LeftMouseButton ()
EndIf
RestoreCursor ()

EndScript 


Script LeggiStatoConnessione ()
; Legge lo stato della connessione alla rete eDonkey.

Var
 int parolatrovata,
 string Connessione 

SaveCursor ()
RaggiungiBarra ("stato")
let Parolatrovata = CercaParola ("eD2K:")
If parolatrovata Then
 NextWord ()
nextword()
 let Connessione = GetWord ()
 If Connessione == "Connesso|" Then 
  SayMessage (ot_jaws_message, MsgConnesso_L, MsgConnesso_S)
 ElIf Connessione == ("Non ") Then 
  SayMessage (ot_jaws_message, MsgDisconnesso_L, MsgDisconnesso_S)
 Else
  SayMessage (ot_jaws_message, MsgIgnoroConnessioneEdonkey_L, MsgIgnoroConnessioneEdonkey_S)
 EndIf
EndIf 
RestoreCursor ()

EndScript


Script VelocitaInDownload ()
; Dice la velocit complessiva dei download in corso.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("stato")
let Parolatrovata = CercaParola ("|Down:")
If parolatrovata Then
 NEXTWORD ()
nextword()
nextword()
 SayMessage (ot_jaws_message, MsgVelocitaInDownload_L, MsgVelocitaInDownLoad_S)
 SayWord ()
Endif
RestoreCursor ()

EndScript


Script VelocitaInUpload ()
; Dice la velocit complessiva degli upload in corso.

Var
 int parolatrovata

SaveCursor ()
RaggiungiBarra ("stato")
Let parolatrovata = CercaParola ("Up:")
If parolatrovata Then
 NextWord ()
nextword()
 SayMessage (ot_jaws_message, MsgVelocitaInUpload_L, MsgVelocitaInUpload_S)
 SayWord ()
EndIf
RestoreCursor ()

EndScript


Script LeggiNumeroDownload ()
; Dice quanti sono i download in corso nella categoria attualmente visualizzata.

Var
 int parolatrovata,
 int LivelloPunteggiatura,
 string SNumeroDownload 

SaveCursor ()
RaggiungiBarra ("strumenti")
NextLine ()
let Parolatrovata = CercaParola ("Download")
If Parolatrovata Then
 NextWord ()
 let SNumeroDownload = FormatString (MsgNumeroDownload, GetWord ())
 let LivelloPunteggiatura = GetVoicePunctuation (vctx_global)
 If LivelloPunteggiatura > 0 Then
  SetVoicePunctuation (vctx_global, 0)
  SayMessage (ot_jaws_message, SNumeroDownload, GetWord ())
  SetVoicePunctuation (vctx_global, LivelloPunteggiatura)
 Else
  SayMessage (ot_jaws_message, SNumeroDownload, GetWord ())
 EndIf
EndIf
RestoreCursor ()

EndScript 


Script Categorie ()
; Dice quanti sono i download in corso, , suddivisi per categorie. 
; Se chiamato due volte, attiva l'elenco delle categorie, che si pu quindi scorrere con le frecce orizzontali.

SaveCursor ()
RaggiungiBarra ("Strumenti")
NextLine ()
CercaParola ("Tutti")
If IsSameScript () Then
 SayMessage (ot_jaws_message, MsgCategorie_L, MsgCategorie_S)
 RouteJAWSToInvisible ()
 LeftMouseButton ()
 Delay (10)
 RoutePcToInvisible ()
Else
 SayFromCursor () 
EndIf 
RestoreCursor ()

EndScript
